%script de prueba de la funciones de la practica 5
%Mensaje general de las prcticas
displayReadme;
input('Pulsa una tecla para comenzar la ejecucin');

%Caso 1********************************************************************
disp('Procesando caso 1 *************************************************')
n=6;
x       =[0 0 1;1 1 1;1 1 1;0 0 0;0 0 1;0 1 0;1 1 1];
k=size(x,2);
ruidosecuencia = generarRuido(n*size(x,1),0.2,2,1, 132);
ruido   =secuenciaEnFilas(ruidosecuencia, n);

[G]=matrizGeneratriz(n,k);
Gcorrecta = [     1     0     0     1     0     1
     0     1     0     0     1     0
     0     0     1     1     0     1];
[flagSize,flagEquality] = comparaMatrices(G,Gcorrecta);
if flagSize
    mensaje = ['Dimensiones de la matriz generatriz equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matriz generatriz equivocada'];
    error(mensaje);
end
disp('Funcin matrizGeneratriz() BIEN');
codigo = codifica(x, G);
codigoCorrecto = [     
     0     0     1     1     0     1
     1     1     1     0     1     0
     1     1     1     0     1     0
     0     0     0     0     0     0
     0     0     1     1     0     1
     0     1     0     0     1     0
     1     1     1     0     1     0];
[flagSize,flagEquality] = comparaMatrices(codigo,codigoCorrecto);
if flagSize
    mensaje = ['Dimensiones del cdigo equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['codigo equivocado'];
    error(mensaje);
end
disp('Funcin codifica() BIEN');

[H] = matrizChequeoParidad(G, n, k);
Hcorrecta=[  1     0     1     1     0     0
     0     1     0     0     1     0
     1     0     1     0     0     1];
[flagSize,flagEquality] = comparaMatrices(H,Hcorrecta);
if flagSize
    mensaje = ['Dimensiones de matrizChequeoParidad (matriz H) equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matrizChequeoParidad (matriz H) equivocada'];
    error(mensaje);
end

disp('Funcin matrizChequeoParidad() BIEN');


codigoRuidoso = mod(codigo+ruido,2);
[sindromes, errores] = calculoSindrome(codigoRuidoso, H);
sindromesCorrectos = [
     0     0     0
     1     0     0
     1     1     0
     0     0     0
     0     0     0
     0     0     0
     1     1     1];
erroresCorrectos = [
     0
     1
     1
     0
     0
     0
     1];
[flagSize,flagEquality] = comparaMatrices(sindromes,sindromesCorrectos);
if flagSize
    mensaje = ['Dimensiones de sindrome equivocado'];
    error(mensaje);
end
if flagEquality
    mensaje = ['sindrome equivocado'];
    error(mensaje);
end
[flagSize,flagEquality] = comparaMatrices(errores,erroresCorrectos);
if flagSize
    mensaje = ['Dimensiones de errores equivocado'];
    error(mensaje);
end
if flagEquality
    mensaje = ['errores equivocados'];
    error(mensaje);
end
disp('Funcin calculoSindrome() BIEN');

palabrasMensaje = generaPosiblesPalabras(k);
palabrasCodigo = codifica(palabrasMensaje,G);
[matrizStandard] = generaMatrizStandard(palabrasCodigo);
matrizStandardCorrecta = [0	0	0	0	0	0	0	0	1	1	0	1	0	1	0	0	1	0	0	1	1	1	1	1	1	0	0	1	0	1	1	0	1	0	0	0	1	1	0	1	1	1	1	1	1	0	1	0
0	0	0	0	0	1	0	0	1	1	0	0	0	1	0	0	1	1	0	1	1	1	1	0	1	0	0	1	0	0	1	0	1	0	0	1	1	1	0	1	1	0	1	1	1	0	1	1
0	0	0	0	1	0	0	0	1	1	1	1	0	1	0	0	0	0	0	1	1	1	0	1	1	0	0	1	1	1	1	0	1	0	1	0	1	1	0	1	0	1	1	1	1	0	0	0
0	0	0	1	0	0	0	0	1	0	0	1	0	1	0	1	1	0	0	1	1	0	1	1	1	0	0	0	0	1	1	0	1	1	0	0	1	1	0	0	1	1	1	1	1	1	1	0
0	0	1	0	0	0	0	0	0	1	0	1	0	1	1	0	1	0	0	1	0	1	1	1	1	0	1	1	0	1	1	0	0	0	0	0	1	1	1	1	1	1	1	1	0	0	1	0
0	0	0	0	1	1	0	0	1	1	1	0	0	1	0	0	0	1	0	1	1	1	0	0	1	0	0	1	1	0	1	0	1	0	1	1	1	1	0	1	0	0	1	1	1	0	0	1
0	0	0	1	1	0	0	0	1	0	1	1	0	1	0	1	0	0	0	1	1	0	0	1	1	0	0	0	1	1	1	0	1	1	1	0	1	1	0	0	0	1	1	1	1	1	0	0
0	0	1	0	1	0	0	0	0	1	1	1	0	1	1	0	0	0	0	1	0	1	0	1	1	0	1	1	1	1	1	0	0	0	1	0	1	1	1	1	0	1	1	1	0	0	0	0

];
[flagSize,flagEquality] = comparaMatrices( cell2mat(matrizStandard),matrizStandardCorrecta);
if flagSize
    mensaje = ['Dimensiones de la matriz estndar equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matriz estndar equivocada'];
    error(mensaje);
end
codigoCorregido = [];
codigoCorregidoCorrecto=[        
     0     0     1     1     0     1
     1     1     0     1     1     1
     0     1     1     1     1     1
     0     0     0     0     0     0
     0     0     1     1     0     1
     0     1     0     0     1     0
     0     0     0     0     0     0];
for i=1:size(codigoRuidoso,1)
    palabra = codigoRuidoso(i,:);
    [palabraCorregida] = corregirPalabra(palabra, matrizStandard, H);
    codigoCorregido = [codigoCorregido;palabraCorregida];
end
[flagSize,flagEquality] = comparaMatrices(codigoCorregido,codigoCorregidoCorrecto);
if flagSize
    mensaje = ['Correccin de cdigo incorrecta'];
    error(mensaje);
end
if flagEquality
    mensaje = ['Correccin de cdigo incorrecta'];
    error(mensaje);
end
disp('Funcin corregirPalabra() BIEN');

%Caso 2********************************************************************
disp('Procesando caso 2 *************************************************')
n=6;
x       =[0 0 1 0;1 1 1 1;1 1 0 1;0 1 0 0;0 0 0 0;1 0 1 0;0 1 1 1];
k=size(x,2);
ruidosecuencia = generarRuido(n*size(x,1),0.2,2,1, 131);
ruido   =secuenciaEnFilas(ruidosecuencia, n);

[G]=matrizGeneratriz(n,k);
Gcorrecta = [     1     0     0     0     1     0
     0     1     0     0     0     1
     0     0     1     0     1     0
     0     0     0     1     0     1];
[flagSize,flagEquality] = comparaMatrices(G,Gcorrecta);
if flagSize
    mensaje = ['Dimensiones de la matriz generatriz equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matriz generatriz equivocada'];
    error(mensaje);
end
disp('Funcin matrizGeneratriz() BIEN');
codigo = codifica(x, G);
codigoCorrecto = [   
     0     0     1     0     1     0
     1     1     1     1     0     0
     1     1     0     1     1     0
     0     1     0     0     0     1
     0     0     0     0     0     0
     1     0     1     0     0     0
     0     1     1     1     1     0];
[flagSize,flagEquality] = comparaMatrices(codigo,codigoCorrecto);
if flagSize
    mensaje = ['Dimensiones del cdigo equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['codigo equivocado'];
    error(mensaje);
end
disp('Funcin codifica() BIEN');

[H] = matrizChequeoParidad(G, n, k);
Hcorrecta=[     1     0     1     0     1     0
     0     1     0     1     0     1];
[flagSize,flagEquality] = comparaMatrices(H,Hcorrecta);
if flagSize
    mensaje = ['Dimensiones de matrizChequeoParidad(matriz H) equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matrizChequeoParidad(matriz H) equivocada'];
    error(mensaje);
end

disp('Funcin matrizChequeoParidad() BIEN');


codigoRuidoso = mod(codigo+ruido,2);
[sindromes, errores] = calculoSindrome(codigoRuidoso, H);
sindromesCorrectos = [
       0     0
     1     0
     0     0
     1     1
     1     0
     1     1
     1     0];
erroresCorrectos = [
        0
     1
     0
     1
     1
     1
     1];
[flagSize,flagEquality] = comparaMatrices(sindromes,sindromesCorrectos);
if flagSize
    mensaje = ['Dimensiones de sindrome equivocado'];
    error(mensaje);
end
if flagEquality
    mensaje = ['sindrome equivocado'];
    error(mensaje);
end
[flagSize,flagEquality] = comparaMatrices(errores,erroresCorrectos);
if flagSize
    mensaje = ['Dimensiones de errores equivocado'];
    error(mensaje);
end
if flagEquality
    mensaje = ['errores equivocados'];
    error(mensaje);
end
disp('Funcin calculoSindrome() BIEN');

palabrasMensaje = generaPosiblesPalabras(k);
palabrasCodigo = codifica(palabrasMensaje,G);
[matrizStandard] = generaMatrizStandard(palabrasCodigo);
matrizStandardCorrecta = [0	0	0	0	0	0	0	0	0	1	0	1	0	0	1	0	1	0	0	0	1	1	1	1	0	1	0	0	0	1	0	1	0	1	0	0	0	1	1	0	1	1	0	1	1	1	1	0	1	0	0	0	1	0	1	0	0	1	1	1	1	0	1	0	0	0	1	0	1	1	0	1	1	1	0	0	1	1	1	1	0	1	1	0	1	1	1	0	0	1	1	1	1	1	0	0
0	0	0	0	0	1	0	0	0	1	0	0	0	0	1	0	1	1	0	0	1	1	1	0	0	1	0	0	0	0	0	1	0	1	0	1	0	1	1	0	1	0	0	1	1	1	1	1	1	0	0	0	1	1	1	0	0	1	1	0	1	0	1	0	0	1	1	0	1	1	0	0	1	1	0	0	1	0	1	1	0	1	1	1	1	1	1	0	0	0	1	1	1	1	0	1
0	0	0	0	1	0	0	0	0	1	1	1	0	0	1	0	0	0	0	0	1	1	0	1	0	1	0	0	1	1	0	1	0	1	1	0	0	1	1	0	0	1	0	1	1	1	0	0	1	0	0	0	0	0	1	0	0	1	0	1	1	0	1	0	1	0	1	0	1	1	1	1	1	1	0	0	0	1	1	1	0	1	0	0	1	1	1	0	1	1	1	1	1	1	1	0
0	0	0	0	1	1	0	0	0	1	1	0	0	0	1	0	0	1	0	0	1	1	0	0	0	1	0	0	1	0	0	1	0	1	1	1	0	1	1	0	0	0	0	1	1	1	0	1	1	0	0	0	0	1	1	0	0	1	0	0	1	0	1	0	1	1	1	0	1	1	1	0	1	1	0	0	0	0	1	1	0	1	0	1	1	1	1	0	1	0	1	1	1	1	1	1
];
[flagSize,flagEquality] = comparaMatrices( cell2mat(matrizStandard),matrizStandardCorrecta);
if flagSize
    mensaje = ['Dimensiones de la matriz estndar equivocadas'];
    error(mensaje);
end
if flagEquality
    mensaje = ['matriz estndar equivocada'];
    error(mensaje);
end
codigoCorregido = [];
codigoCorregidoCorrecto=[   1     1     1     1     0     0
     1     1     1     1     0     0
     1     1     0     1     1     0
     0     1     0     0     0     1
     1     1     1     1     0     0
     1     1     0     0     1     1
     0     0     0     0     0     0];
for i=1:size(codigoRuidoso,1)
    palabra = codigoRuidoso(i,:);
    [palabraCorregida] = corregirPalabra(palabra, matrizStandard, H);
    codigoCorregido = [codigoCorregido;palabraCorregida];
end
[flagSize,flagEquality] = comparaMatrices(codigoCorregido,codigoCorregidoCorrecto);
if flagSize
    mensaje = ['Correccin de cdigo incorrecta'];
    error(mensaje);
end
if flagEquality
    mensaje = ['Correccin de cdigo incorrecta'];
    error(mensaje);
end
disp('Funcin corregirPalabra() BIEN');
